diff --git a/debian/changelog b/debian/changelog
index f570024..5cd7f0f 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,3 +1,13 @@
+s390-tools (2.14.0-1ubuntu1.1) groovy; urgency=medium
+
+  * debian/patches/s390-tools-sru-lp1903984-groovy.patch
+    zcryptstats: Fix handling of partial results with many domains
+    - zconf/zcrypt/zcryptstats.c: code fix to pass the correct next-domain
+      to the subsequent CHSC call of a partial response
+    Thanks to Ingo Franzki <ifranzki@linux.ibm.com>
+
+ -- Frank Heimes <frank.heimes@canonical.com>  Tue, 19 Jan 2021 12:06:06 +0100
+
 s390-tools (2.14.0-1ubuntu1) groovy; urgency=medium
 
   * Merge from Debian, remaining changes:
diff --git a/debian/files b/debian/files
new file mode 100644
index 0000000..b53bf95
--- /dev/null
+++ b/debian/files
@@ -0,0 +1 @@
+s390-tools_2.12.0-0ubuntu3.2~ppa1_source.buildinfo admin optional
diff --git a/debian/patches/s390-tools-sru-lp1903984-groovy.patch b/debian/patches/s390-tools-sru-lp1903984-groovy.patch
new file mode 100644
index 0000000..eb949ed
--- /dev/null
+++ b/debian/patches/s390-tools-sru-lp1903984-groovy.patch
@@ -0,0 +1,48 @@
+Description: zcryptstats fails
+ The zcryptstats tool reports data for only the last two domain IDs.
+ Further, it hangs if one collect data for a complete crypto card,
+ and then one has to kill the ssh session to get back.
+ Patch/commit is:
+ cf2311f cf2311f1f1de17435b49ba8c8697be91705ba031
+ "zcryptstats: Fix handling of partial results with many domains"
+Author: Ingo Franzki <ifranzki@linux.ibm.com>
+Origin: backport
+Bug-IBM: IBM Bugzilla 189183
+Bug-Ubuntu: https://bugs.launchpad.net/bugs/1903984
+Forwarded: not-needed
+Applied-Upstream: upstream patch/commits:
+ https://github.com/ibm-s390-tools/s390-tools/commit/cf2311f1f1de17435b49ba8c8697be91705ba031
+Reviewed-by: Frank Heimes <frank.heimes@canonical.com>
+Last-Update: 2021-01-19
+---
+This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
+--- a/zconf/zcrypt/zcryptstats.c
++++ b/zconf/zcrypt/zcryptstats.c
+@@ -1178,8 +1178,14 @@
+ 		scdmd_area.request.header.code = 0x102d;
+ 		scdmd_area.request.header.length =
+ 				sizeof(struct chsc_scdmd_request);
+-		scdmd_area.request.first_drid.ap_index = card;
+-		scdmd_area.request.first_drid.domain_index = g.min_domain;
++		if (scdmd_area.response.p) {
++			scdmd_area.request.first_drid =
++						scdmd_area.response.crid;
++		} else {
++			scdmd_area.request.first_drid.ap_index = card;
++			scdmd_area.request.first_drid.domain_index =
++								g.min_domain;
++		}
+ 		scdmd_area.request.last_drid.ap_index = card;
+ 		scdmd_area.request.last_drid.domain_index = g.max_domain;
+ 		scdmd_area.request.s = 1;
+@@ -1217,10 +1223,6 @@
+ 		rc = process_apqn_measurement_data(&scdmd_area);
+ 		if (rc != 0)
+ 			break;
+-
+-		if (scdmd_area.response.p)
+-			scdmd_area.request.first_drid =
+-					scdmd_area.response.crid;
+ 	} while (scdmd_area.response.p);
+ 
+ 	return rc;
diff --git a/debian/patches/series b/debian/patches/series
index 74ab653..c3dd3aa 100644
--- a/debian/patches/series
+++ b/debian/patches/series
@@ -6,3 +6,4 @@ sg3-utils.patch
 0001-zkey-add-initramfs-hook.patch
 0001-zkey-on-Ubuntu-use-default-benchmarked-Argon2i-with-.patch
 0001-dumpconf-Don-t-run-the-service-in-LXC.patch
+s390-tools-sru-lp1903984-groovy.patch
